unit umainform;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VCL.TMSFNCTypes, VCL.TMSFNCUtils,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, VCL.TMSFNCCustomControl,
  VCL.TMSFNCPlannerBase, VCL.TMSFNCPlannerData, VCL.TMSFNCPlanner,
  VCL.TMSFNCCustomComponent, VCL.TMSFNCPlannerItemEditorRecurrency, Data.DB,
  Vcl.Grids, Vcl.DBGrids, MemDS, VirtualTable, VCL.TMSFNCPlannerDatabaseAdapter,
  Vcl.StdCtrls, Vcl.ExtCtrls, Datasnap.DBClient, Datasnap.Provider, eventDialog;

type
  TForm3 = class(TForm)
    TMSFNCPlanner1: TTMSFNCPlanner;
    DataSource1: TDataSource;
    TMSFNCPlannerDatabaseAdapter1: TTMSFNCPlannerDatabaseAdapter;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ClientDataSet1: TClientDataSet;
    DataSetProvider1: TDataSetProvider;
    procedure TMSFNCPlanner1AfterInsertItem(Sender: TObject; AStartTime,
      AEndTime: TDateTime; APosition: Integer; AItem: TTMSFNCPlannerItem);
    procedure TMSFNCPlanner1AfterItemChanged(Sender: TObject;
      AItem: TTMSFNCPlannerItem);
    procedure TMSFNCPlanner1BeforeDeleteItem(Sender: TObject;
      AItem: TTMSFNCPlannerItem; AMode: TTMSFNCPlannerItemDeleteMode;
      var ACanDelete: Boolean);
    procedure TMSFNCPlanner1AfterUpdateItem(Sender: TObject; AStartTime,
      AEndTime: TDateTime; APosition: Integer; AItem: TTMSFNCPlannerItem);
    procedure Button3Click(Sender: TObject);
    procedure TMSFNCPlanner1BeforeOpenInsertDialog(Sender: TObject; AStartTime,
      AEndTime: TDateTime; APosition: Integer; var ACanOpen: Boolean);
    procedure TMSFNCPlanner1BeforeOpenUpdateDialog(Sender: TObject; AStartTime,
      AEndTime: TDateTime; APosition: Integer; AItem: TTMSFNCPlannerItem;
      var ACanOpen: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation



{$R *.dfm}




procedure TForm3.Button3Click(Sender: TObject);
begin
if Assigned(TMSFNCPlanner1.Adapter) then
    TMSFNCPlanner1.Adapter.DeleteItem(TMSFNCPlanner1.SelectedItems[0])
  else
    TMSFNCPlanner1.Items.Delete(TMSFNCPlanner1.SelectedItems.Items[0].Index);
end;

procedure TForm3.TMSFNCPlanner1AfterInsertItem(Sender: TObject; AStartTime,
  AEndTime: TDateTime; APosition: Integer; AItem: TTMSFNCPlannerItem);
begin
  //TMSFNCPlannerDatabaseAdapter1.InsertItem(AItem) ;

end;

procedure TForm3.TMSFNCPlanner1AfterItemChanged(Sender: TObject;
  AItem: TTMSFNCPlannerItem);
begin
  TMSFNCPlannerDatabaseAdapter1.UpdateItem(AItem);
end;

procedure TForm3.TMSFNCPlanner1AfterUpdateItem(Sender: TObject; AStartTime,
  AEndTime: TDateTime; APosition: Integer; AItem: TTMSFNCPlannerItem);
begin
TMSFNCPlannerDatabaseAdapter1.UpdateItem(AItem);
end;

procedure TForm3.TMSFNCPlanner1BeforeDeleteItem(Sender: TObject;
  AItem: TTMSFNCPlannerItem; AMode: TTMSFNCPlannerItemDeleteMode;
  var ACanDelete: Boolean);
begin
  TMSFNCPlannerDatabaseAdapter1.DeleteItem(AItem);
end;

procedure TForm3.TMSFNCPlanner1BeforeOpenInsertDialog(Sender: TObject;
  AStartTime, AEndTime: TDateTime; APosition: Integer; var ACanOpen: Boolean);
var
  ADialog: TForm4;
  AItem: TTMSFNCPlannerItem;
begin
   ACanOpen := False ;
   ADialog := TForm4.Create(nil);
   ADialog.TMSFNCDateTimePicker1.SelectedDateTime := AStartTime;
   ADialog.TMSFNCDateTimePicker2.SelectedDateTime := AEndTime;
  if ADialog.ShowModal = mrOk then
  begin
  AStartTime := ADialog.TMSFNCDateTimePicker1.SelectedDateTime;
  AEndTime := ADialog.TMSFNCDateTimePicker2.SelectedDateTime;
  AItem := TMSFNCPlanner1.AddItem(AStartTime, AEndTime);
  TMSFNCPlannerDatabaseAdapter1.InsertItem(AItem) ;
  TMSFNCPlannerDatabaseAdapter1.SelectItem(AItem);
  TMSFNCPlanner1.SelectItem(Aitem);
  end else
  begin
    Exit;
  end;
end;

procedure TForm3.TMSFNCPlanner1BeforeOpenUpdateDialog(Sender: TObject;
  AStartTime, AEndTime: TDateTime; APosition: Integer;
  AItem: TTMSFNCPlannerItem; var ACanOpen: Boolean);
var
  ADialog: TForm4;
begin
  ACanOpen := False;
  ADialog := TForm4.Create(nil);
  ADialog.ShowModal;

end;

end.
